
Light_32Receiver_Send_Result:

;Light Receiver.mbas,75 :: 		Sub Procedure Send_Result ()
;Light Receiver.mbas,76 :: 		Stat_Return = 0                              'need to add an error Test in this loop ******
	CLRF       _Stat_return+0
;Light Receiver.mbas,77 :: 		For i = 0 to 1
	CLRF       _i+0
L_Light_32Receiver_Send_Result2:
;Light Receiver.mbas,78 :: 		SR_01:
L_Light_32Receiver_Send_Result_sr_01:
;Light Receiver.mbas,79 :: 		if (UART1_Tx_Idle = 1)
	CALL       _UART1_TX_Idle+0
	MOVF       R0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L_Light_32Receiver_Send_Result8
;Light Receiver.mbas,81 :: 		UART1_Write(uart_out_buff [i])            ' write the byte
	MOVLW      _uart_out_buff+0
	MOVWF      FSR0L
	MOVLW      hi_addr(_uart_out_buff+0)
	MOVWF      FSR0H
	MOVF       _i+0, 0
	ADDWF      FSR0L, 1
	BTFSC      STATUS+0, 0
	INCF       FSR0H, 1
	MOVF       INDF0+0, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
	GOTO       L_Light_32Receiver_Send_Result9
;Light Receiver.mbas,82 :: 		else
L_Light_32Receiver_Send_Result8:
;Light Receiver.mbas,83 :: 		GoTo SR_01
	GOTO       L_Light_32Receiver_Send_Result_sr_01
;Light Receiver.mbas,84 :: 		end if
L_Light_32Receiver_Send_Result9:
;Light Receiver.mbas,85 :: 		next i                                              'two bytes
	MOVF       _i+0, 0
	XORLW      1
	BTFSC      STATUS+0, 2
	GOTO       L_Light_32Receiver_Send_Result5
	INCF       _i+0, 1
	GOTO       L_Light_32Receiver_Send_Result2
L_Light_32Receiver_Send_Result5:
;Light Receiver.mbas,86 :: 		end Sub
L_end_Send_Result:
	RETURN
; end of Light_32Receiver_Send_Result

Light_32Receiver_Read_ATD_Sensors:

;Light Receiver.mbas,88 :: 		Sub Procedure Read_ATD_Sensors ()
;Light Receiver.mbas,89 :: 		ATD_Results = Null
	CLRF       _ATD_Results+0
;Light Receiver.mbas,90 :: 		For j = 0 to 3                                       'Average four sensors
	CLRF       _j+0
L_Light_32Receiver_Read_ATD_Sensors12:
;Light Receiver.mbas,91 :: 		ADC_Current_Data [j] = Word_Null                    'This routine takes 12.2 MS
	MOVF       _j+0, 0
	MOVWF      R0
	CLRF       R1
	LSLF       R0, 1
	RLF        R1, 1
	MOVLW      _ADC_Current_Data+0
	ADDWF      R0, 0
	MOVWF      FSR1L
	MOVLW      hi_addr(_ADC_Current_Data+0)
	ADDWFC     R1, 0
	MOVWF      FSR1H
	CLRF       INDF1+0
	ADDFSR     1, 1
	CLRF       INDF1+0
;Light Receiver.mbas,92 :: 		ADC_Data = Word_Null                                'zero out the data
	CLRF       _ADC_Data+0
	CLRF       _ADC_Data+1
;Light Receiver.mbas,93 :: 		for i = 0 to 32                                  'average thirty two (32) samples each
	CLRF       _i+0
L_Light_32Receiver_Read_ATD_Sensors17:
;Light Receiver.mbas,94 :: 		ADC_Data = ADC_Data + ADC_Read(j)            'read analog value from ADC module channel
	MOVF       _j+0, 0
	MOVWF      FARG_ADC_Read_channel+0
	CALL       _ADC_Read+0
	MOVF       R0, 0
	ADDWF      _ADC_Data+0, 1
	MOVF       R1, 0
	ADDWFC     _ADC_Data+1, 1
;Light Receiver.mbas,95 :: 		next i                                           'four sensors
	MOVF       _i+0, 0
	XORLW      32
	BTFSC      STATUS+0, 2
	GOTO       L_Light_32Receiver_Read_ATD_Sensors20
	INCF       _i+0, 1
	GOTO       L_Light_32Receiver_Read_ATD_Sensors17
L_Light_32Receiver_Read_ATD_Sensors20:
;Light Receiver.mbas,97 :: 		ADC_Current_Data [j] = ADC_Data                  'total of 32 samples
	MOVF       _j+0, 0
	MOVWF      R0
	CLRF       R1
	LSLF       R0, 1
	RLF        R1, 1
	MOVLW      _ADC_Current_Data+0
	ADDWF      R0, 0
	MOVWF      FSR1L
	MOVLW      hi_addr(_ADC_Current_Data+0)
	ADDWFC     R1, 0
	MOVWF      FSR1H
	MOVF       _ADC_Data+0, 0
	MOVWF      INDF1+0
	MOVF       _ADC_Data+1, 0
	ADDFSR     1, 1
	MOVWF      INDF1+0
;Light Receiver.mbas,98 :: 		if (ABS((ADC_Current_Data [j] - ADC_Cal_Data [j])) > 100)  ' Need 100 Delta Min when Lights are on.
	MOVF       _j+0, 0
	MOVWF      R0
	CLRF       R1
	LSLF       R0, 1
	RLF        R1, 1
	MOVLW      _ADC_Current_Data+0
	ADDWF      R0, 0
	MOVWF      R2
	MOVLW      hi_addr(_ADC_Current_Data+0)
	ADDWFC     R1, 0
	MOVWF      R3
	MOVLW      _ADC_CAL_Data+0
	ADDWF      R0, 0
	MOVWF      FSR0L
	MOVLW      hi_addr(_ADC_CAL_Data+0)
	ADDWFC     R1, 0
	MOVWF      FSR0H
	MOVF       INDF0+0, 0
	MOVWF      R0
	ADDFSR     0, 1
	MOVF       INDF0+0, 0
	MOVWF      R1
	MOVF       R2, 0
	MOVWF      FSR0L
	MOVF       R3, 0
	MOVWF      FSR0H
	MOVF       R0, 0
	SUBWF      INDF0+0, 0
	MOVWF      FARG_abs_a+0
	MOVF       R1, 0
	ADDFSR     0, 1
	SUBWFB     INDF0+0, 0
	MOVWF      FARG_abs_a+1
	CALL       _abs+0
	MOVLW      128
	MOVWF      R2
	MOVLW      128
	XORWF      R1, 0
	SUBWF      R2, 0
	BTFSS      STATUS+0, 2
	GOTO       L_Light_32Receiver_Read_ATD_Sensors201
	MOVF       R0, 0
	SUBLW      100
L_Light_32Receiver_Read_ATD_Sensors201:
	BTFSC      STATUS+0, 0
	GOTO       L_Light_32Receiver_Read_ATD_Sensors22
;Light Receiver.mbas,100 :: 		ATD_RESULTS.(j) = 1                    ' Prefilled so just log the On state
	MOVF       _j+0, 0
	MOVWF      R1
	MOVLW      1
	MOVWF      R0
	MOVF       R1, 0
L_Light_32Receiver_Read_ATD_Sensors202:
	BTFSC      STATUS+0, 2
	GOTO       L_Light_32Receiver_Read_ATD_Sensors203
	LSLF       R0, 1
	ADDLW      255
	GOTO       L_Light_32Receiver_Read_ATD_Sensors202
L_Light_32Receiver_Read_ATD_Sensors203:
	MOVF       R0, 0
	IORWF       _ATD_Results+0, 1
L_Light_32Receiver_Read_ATD_Sensors22:
;Light Receiver.mbas,102 :: 		next j
	MOVF       _j+0, 0
	XORLW      3
	BTFSC      STATUS+0, 2
	GOTO       L_Light_32Receiver_Read_ATD_Sensors15
	INCF       _j+0, 1
	GOTO       L_Light_32Receiver_Read_ATD_Sensors12
L_Light_32Receiver_Read_ATD_Sensors15:
;Light Receiver.mbas,104 :: 		end Sub
L_end_Read_ATD_Sensors:
	RETURN
; end of Light_32Receiver_Read_ATD_Sensors

Light_32Receiver_Get_Command:

;Light Receiver.mbas,106 :: 		Sub Procedure Get_Command ()                               'Get a two-byte command into uart_in_buffer, report 0 = good, 1 = bad
;Light Receiver.mbas,107 :: 		Stat_Return = 0                              'need to add an error Test in this loop ******
	CLRF       _Stat_return+0
;Light Receiver.mbas,108 :: 		For i = 0 to 1
	CLRF       _i+0
L_Light_32Receiver_Get_Command28:
;Light Receiver.mbas,109 :: 		GC_01:
L_Light_32Receiver_Get_Command_gc_01:
;Light Receiver.mbas,110 :: 		if (UART1_Data_Ready() = 1)                      'If data is received
	CALL       _UART1_Data_Ready+0
	MOVF       R0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L_Light_32Receiver_Get_Command34
;Light Receiver.mbas,112 :: 		uart_in_buff [i] = UART1_Read()           'read the received data
	MOVLW      _uart_in_buff+0
	MOVWF      FLOC_Light_32Receiver_Get_Command+0
	MOVLW      hi_addr(_uart_in_buff+0)
	MOVWF      FLOC_Light_32Receiver_Get_Command+1
	MOVF       _i+0, 0
	ADDWF      FLOC_Light_32Receiver_Get_Command+0, 1
	BTFSC      STATUS+0, 0
	INCF       FLOC_Light_32Receiver_Get_Command+1, 1
	CALL       _UART1_Read+0
	MOVF       FLOC_Light_32Receiver_Get_Command+0, 0
	MOVWF      FSR1L
	MOVF       FLOC_Light_32Receiver_Get_Command+1, 0
	MOVWF      FSR1H
	MOVF       R0, 0
	MOVWF      INDF1+0
	GOTO       L_Light_32Receiver_Get_Command35
;Light Receiver.mbas,114 :: 		else
L_Light_32Receiver_Get_Command34:
;Light Receiver.mbas,115 :: 		GoTo GC_01
	GOTO       L_Light_32Receiver_Get_Command_gc_01
;Light Receiver.mbas,116 :: 		end if
L_Light_32Receiver_Get_Command35:
;Light Receiver.mbas,117 :: 		next i                                               'two bytes
	MOVF       _i+0, 0
	XORLW      1
	BTFSC      STATUS+0, 2
	GOTO       L_Light_32Receiver_Get_Command31
	INCF       _i+0, 1
	GOTO       L_Light_32Receiver_Get_Command28
L_Light_32Receiver_Get_Command31:
;Light Receiver.mbas,118 :: 		uart_in_buff [0] = uart_in_buff [0] and 0xDF         'First char to upper case
	MOVLW      223
	ANDWF      _uart_in_buff+0, 1
;Light Receiver.mbas,120 :: 		end Sub
L_end_Get_Command:
	RETURN
; end of Light_32Receiver_Get_Command

_main:

;Light Receiver.mbas,123 :: 		main:
;Light Receiver.mbas,124 :: 		OSCCON  = 0x72                                           'Set the internal OSC to 8MHz
	MOVLW      114
	MOVWF      OSCCON+0
;Light Receiver.mbas,125 :: 		ADCON1  = 0xE3                                           'FVR Right Justified
	MOVLW      227
	MOVWF      ADCON1+0
;Light Receiver.mbas,126 :: 		FVRCON  = 0xC2                                           '2.048 FVR
	MOVLW      194
	MOVWF      FVRCON+0
;Light Receiver.mbas,127 :: 		APFCON0 = 0x00                                           'Uart is on RC4 and RC5
	CLRF       APFCON0+0
;Light Receiver.mbas,128 :: 		ANSELA  = 0x17                                           'Configure PORTA pins as Analog
	MOVLW      23
	MOVWF      ANSELA+0
;Light Receiver.mbas,129 :: 		ANSELC  = 0x00                                           'All PORTC Pins are Digital
	CLRF       ANSELC+0
;Light Receiver.mbas,130 :: 		TRISA   = 0x3f                                           'All PORTA pins are inputs
	MOVLW      63
	MOVWF      TRISA+0
;Light Receiver.mbas,131 :: 		TRISC   = 0x20                                           'All outputs except RC5, which Rx for uart
	MOVLW      32
	MOVWF      TRISC+0
;Light Receiver.mbas,132 :: 		ADC_Init                                                 'Start up the converter
	CALL       _ADC_Init+0
;Light Receiver.mbas,133 :: 		PortC = PortC and 0xF0                                   'Clear the Lights
	MOVLW      240
	ANDWF      PORTC+0, 1
;Light Receiver.mbas,134 :: 		UART1_Init(38400)                                        'Initialize UART module at 38400 bps
	BSF        BAUDCON+0, 3
	MOVLW      51
	MOVWF      SPBRG+0
	CLRF       SPBRG+1
	BSF        TXSTA+0, 2
	CALL       _UART1_Init+0
;Light Receiver.mbas,135 :: 		Delay_ms(3000)                                           'Wait for UART FVR and current sensors modules to stabilize
	MOVLW      31
	MOVWF      R11
	MOVLW      113
	MOVWF      R12
	MOVLW      30
	MOVWF      R13
L__main38:
	DECFSZ     R13, 1
	GOTO       L__main38
	DECFSZ     R12, 1
	GOTO       L__main38
	DECFSZ     R11, 1
	GOTO       L__main38
	NOP
;Light Receiver.mbas,136 :: 		Read_ATD_Sensors                                         'Calibrate ATD inputs
	CALL       Light_32Receiver_Read_ATD_Sensors+0
;Light Receiver.mbas,137 :: 		ADC_Cal_Data = ADC_Current_Data
	MOVLW      _ADC_CAL_Data+0
	MOVWF      FSR1L
	MOVLW      hi_addr(_ADC_CAL_Data+0)
	MOVWF      FSR1H
	MOVLW      _ADC_Current_Data+0
	MOVWF      FSR0L
	MOVLW      hi_addr(_ADC_Current_Data+0)
	MOVWF      FSR0H
	MOVLW      8
	MOVWF      R0
	MOVLW      1
	MOVWF      R1
	CALL       ___CA2A+0
;Light Receiver.mbas,139 :: 		Main_00:
L__main_main_00:
;Light Receiver.mbas,140 :: 		If BT_Ready <> 1
	BTFSC      RA5_bit+0, BitPos(RA5_bit+0)
	GOTO       L__main41
;Light Receiver.mbas,142 :: 		GoTo Main_00
	GOTO       L__main_main_00
L__main41:
;Light Receiver.mbas,146 :: 		if (UART1_Data_Ready() = 1)                         'flush any char in buffer
	CALL       _UART1_Data_Ready+0
	MOVF       R0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__main44
;Light Receiver.mbas,148 :: 		i = UART1_Read()
	CALL       _UART1_Read+0
	MOVF       R0, 0
	MOVWF      _i+0
L__main44:
;Light Receiver.mbas,151 :: 		Main_01:
L__main_main_01:
;Light Receiver.mbas,152 :: 		Get_Command ()                                     'Wait for instructions
	CALL       Light_32Receiver_Get_Command+0
;Light Receiver.mbas,153 :: 		if Stat_Return = 1                                 'Look for Error
	MOVF       _Stat_return+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__main48
;Light Receiver.mbas,155 :: 		goto Report_Error
	GOTO       L__main_report_error
L__main48:
;Light Receiver.mbas,157 :: 		uart_out_buff = uart_in_buff                       'Get a copy in the output buffer
	MOVLW      _uart_out_buff+0
	MOVWF      FSR1L
	MOVLW      hi_addr(_uart_out_buff+0)
	MOVWF      FSR1H
	MOVLW      _uart_in_buff+0
	MOVWF      FSR0L
	MOVLW      hi_addr(_uart_in_buff+0)
	MOVWF      FSR0H
	CALL       ___CS2S+0
	CLRF       INDF1+0
;Light Receiver.mbas,160 :: 		Case Light_ON                                  'Turn on a single light command
	MOVF       _uart_in_buff+0, 0
	XORLW      65
	BTFSS      STATUS+0, 2
	GOTO       L__main54
;Light Receiver.mbas,162 :: 		Case 0x01                                  'Must be a single bit on
	MOVF       _uart_in_buff+1, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__main58
;Light Receiver.mbas,163 :: 		goto Light_On_01
	GOTO       L__main_light_on_01
L__main58:
;Light Receiver.mbas,164 :: 		Case 0x02                                  'Two bits are not allowed
	MOVF       _uart_in_buff+1, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L__main62
;Light Receiver.mbas,165 :: 		goto Light_On_01
	GOTO       L__main_light_on_01
L__main62:
;Light Receiver.mbas,166 :: 		Case 0x04                                  'Two bits are not allowed
	MOVF       _uart_in_buff+1, 0
	XORLW      4
	BTFSS      STATUS+0, 2
	GOTO       L__main65
;Light Receiver.mbas,167 :: 		goto Light_On_01
	GOTO       L__main_light_on_01
L__main65:
;Light Receiver.mbas,168 :: 		Case 0x08                                  'Two bits are not allowed
	MOVF       _uart_in_buff+1, 0
	XORLW      8
	BTFSS      STATUS+0, 2
	GOTO       L__main68
;Light Receiver.mbas,169 :: 		goto Light_On_01
	GOTO       L__main_light_on_01
L__main68:
;Light Receiver.mbas,171 :: 		uart_out_buff [0] = uart_in_buff [1]         'send it back error
	MOVF       _uart_in_buff+1, 0
	MOVWF      _uart_out_buff+0
;Light Receiver.mbas,172 :: 		goto Report_error
	GOTO       L__main_report_error
;Light Receiver.mbas,173 :: 		Light_on_01:
L__main_light_on_01:
;Light Receiver.mbas,174 :: 		PortC = PortC or (uart_in_buff [1] and 0x0F)   'Parse and turn on a light
	MOVLW      15
	ANDWF      _uart_in_buff+1, 0
	MOVWF      R0
	MOVF       R0, 0
	IORWF       PORTC+0, 1
;Light Receiver.mbas,176 :: 		Read_ATD_Sensors ()
	CALL       Light_32Receiver_Read_ATD_Sensors+0
;Light Receiver.mbas,177 :: 		uart_out_buff[0] = Fill_Char                   'We like the results
	MOVLW      13
	MOVWF      _uart_out_buff+0
;Light Receiver.mbas,178 :: 		uart_out_buff[1] = ACK
	MOVLW      6
	MOVWF      _uart_out_buff+1
;Light Receiver.mbas,179 :: 		if ATD_Results <> PortC and 0x0F               'Current sensors agree with light port?
	MOVLW      15
	ANDWF      PORTC+0, 0
	MOVWF      R1
	MOVF       _ATD_Results+0, 0
	XORWF      R1, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main70
;Light Receiver.mbas,181 :: 		uart_out_buff [0] = PortC and 0x0F
	MOVLW      15
	ANDWF      PORTC+0, 0
	MOVWF      _uart_out_buff+0
;Light Receiver.mbas,182 :: 		uart_out_buff [0] = uart_out_buff [0] or Swap (Atd_Results)
	MOVF       _ATD_Results+0, 0
	MOVWF      FARG_Swap_arg+0
	CALL       _Swap+0
	MOVF       R0, 0
	IORWF       _uart_out_buff+0, 1
;Light Receiver.mbas,183 :: 		uart_out_buff [1] = NAK                  'No, send status in buff [0] and a Nack
	MOVLW      21
	MOVWF      _uart_out_buff+1
L__main70:
;Light Receiver.mbas,186 :: 		Send_Result
	CALL       Light_32Receiver_Send_Result+0
;Light Receiver.mbas,187 :: 		Goto Main_01                                    'Loop for More
	GOTO       L__main_main_01
L__main54:
;Light Receiver.mbas,189 :: 		Case Light_Off                                    'Turn off a single light Command
	MOVF       _uart_in_buff+0, 0
	XORLW      66
	BTFSS      STATUS+0, 2
	GOTO       L__main74
;Light Receiver.mbas,191 :: 		Case 0x01                                     'Must be a single bit
	MOVF       _uart_in_buff+1, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__main78
;Light Receiver.mbas,192 :: 		goto Light_Off_01
	GOTO       L__main_light_off_01
L__main78:
;Light Receiver.mbas,193 :: 		Case 0x02                                     'two bits are not allowed
	MOVF       _uart_in_buff+1, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L__main82
;Light Receiver.mbas,194 :: 		goto Light_Off_01
	GOTO       L__main_light_off_01
L__main82:
;Light Receiver.mbas,195 :: 		Case 0x04                                     'two bits are not allowed
	MOVF       _uart_in_buff+1, 0
	XORLW      4
	BTFSS      STATUS+0, 2
	GOTO       L__main85
;Light Receiver.mbas,196 :: 		goto Light_Off_01
	GOTO       L__main_light_off_01
L__main85:
;Light Receiver.mbas,197 :: 		Case 0x08                                     'two bits are not allowed
	MOVF       _uart_in_buff+1, 0
	XORLW      8
	BTFSS      STATUS+0, 2
	GOTO       L__main88
;Light Receiver.mbas,198 :: 		goto Light_Off_01
	GOTO       L__main_light_off_01
L__main88:
;Light Receiver.mbas,200 :: 		uart_out_buff [0] = uart_in_buff [1]            'Send it back error
	MOVF       _uart_in_buff+1, 0
	MOVWF      _uart_out_buff+0
;Light Receiver.mbas,201 :: 		GoTo Report_error
	GOTO       L__main_report_error
;Light Receiver.mbas,203 :: 		Light_Off_01:                                               'Turn off Light Command
L__main_light_off_01:
;Light Receiver.mbas,204 :: 		PortC = PortC xor (uart_in_buff [1] and 0x0F)   'Parse and turn on a light
	MOVLW      15
	ANDWF      _uart_in_buff+1, 0
	MOVWF      R0
	MOVF       R0, 0
	XORWF      PORTC+0, 1
;Light Receiver.mbas,205 :: 		Read_ATD_Sensors()                              'Check the ATD here for current
	CALL       Light_32Receiver_Read_ATD_Sensors+0
;Light Receiver.mbas,206 :: 		uart_out_buff [0] = Fill_Char                   'We like the results
	MOVLW      13
	MOVWF      _uart_out_buff+0
;Light Receiver.mbas,207 :: 		uart_out_buff [1] = ACK
	MOVLW      6
	MOVWF      _uart_out_buff+1
;Light Receiver.mbas,208 :: 		if ATD_Results <> PortC and 0x0F                'Do current sonsors agree with light port?
	MOVLW      15
	ANDWF      PORTC+0, 0
	MOVWF      R1
	MOVF       _ATD_Results+0, 0
	XORWF      R1, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main90
;Light Receiver.mbas,210 :: 		uart_out_buff [0] = PortC and 0x0F
	MOVLW      15
	ANDWF      PORTC+0, 0
	MOVWF      _uart_out_buff+0
;Light Receiver.mbas,211 :: 		uart_out_buff [0] = uart_out_buff [0] or Swap (Atd_results)
	MOVF       _ATD_Results+0, 0
	MOVWF      FARG_Swap_arg+0
	CALL       _Swap+0
	MOVF       R0, 0
	IORWF       _uart_out_buff+0, 1
;Light Receiver.mbas,212 :: 		uart_out_buff [1] = NAK                  'No, send status in buff [0] and a NACK
	MOVLW      21
	MOVWF      _uart_out_buff+1
L__main90:
;Light Receiver.mbas,214 :: 		Send_result
	CALL       Light_32Receiver_Send_Result+0
;Light Receiver.mbas,215 :: 		GoTO Main_01                                    'Loop for More
	GOTO       L__main_main_01
L__main74:
;Light Receiver.mbas,217 :: 		Case All_On                                       'Turn on All Lights command
	MOVF       _uart_in_buff+0, 0
	XORLW      67
	BTFSS      STATUS+0, 2
	GOTO       L__main94
;Light Receiver.mbas,218 :: 		if uart_in_buff [1] <> Fill_Char                'second byte must be a fill character
	MOVF       _uart_in_buff+1, 0
	XORLW      13
	BTFSC      STATUS+0, 2
	GOTO       L__main96
;Light Receiver.mbas,220 :: 		goto Report_Error
	GOTO       L__main_report_error
L__main96:
;Light Receiver.mbas,222 :: 		PortC = PortC or 0x0F                           'Turn on all lights
	MOVLW      15
	IORWF       PORTC+0, 1
;Light Receiver.mbas,223 :: 		Read_ATD_Sensors()                              'Check the ATD here for current
	CALL       Light_32Receiver_Read_ATD_Sensors+0
;Light Receiver.mbas,224 :: 		uart_out_buff [0] = Fill_Char                   'We like the results
	MOVLW      13
	MOVWF      _uart_out_buff+0
;Light Receiver.mbas,225 :: 		uart_out_buff [1] = ACK
	MOVLW      6
	MOVWF      _uart_out_buff+1
;Light Receiver.mbas,226 :: 		if ATD_Results <> PortC and 0x0F                'Do current sensors agree with light port?
	MOVLW      15
	ANDWF      PORTC+0, 0
	MOVWF      R1
	MOVF       _ATD_Results+0, 0
	XORWF      R1, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main99
;Light Receiver.mbas,228 :: 		uart_out_buff [0] = PortC and 0x0F
	MOVLW      15
	ANDWF      PORTC+0, 0
	MOVWF      _uart_out_buff+0
;Light Receiver.mbas,229 :: 		uart_out_buff [0] = uart_out_buff [0] or Swap (Atd_Results)
	MOVF       _ATD_Results+0, 0
	MOVWF      FARG_Swap_arg+0
	CALL       _Swap+0
	MOVF       R0, 0
	IORWF       _uart_out_buff+0, 1
;Light Receiver.mbas,230 :: 		uart_out_buff [1] = NAK                  'No, send status in buffer and NAK
	MOVLW      21
	MOVWF      _uart_out_buff+1
L__main99:
;Light Receiver.mbas,232 :: 		Send_Result
	CALL       Light_32Receiver_Send_Result+0
;Light Receiver.mbas,233 :: 		GoTo Main_01                                    'Loop for More
	GOTO       L__main_main_01
L__main94:
;Light Receiver.mbas,235 :: 		Case All_Off                                      'Turn off All Lights command
	MOVF       _uart_in_buff+0, 0
	XORLW      68
	BTFSS      STATUS+0, 2
	GOTO       L__main103
;Light Receiver.mbas,236 :: 		if uart_in_buff [1] <> Fill_Char                'Second byte must be a fill char
	MOVF       _uart_in_buff+1, 0
	XORLW      13
	BTFSC      STATUS+0, 2
	GOTO       L__main105
;Light Receiver.mbas,238 :: 		GoTo Report_Error
	GOTO       L__main_report_error
L__main105:
;Light Receiver.mbas,240 :: 		PortC = PortC and 0xF0                          'Turn off all Lights
	MOVLW      240
	ANDWF      PORTC+0, 1
;Light Receiver.mbas,241 :: 		Read_ATD_Sensors()                              'Check the ATD here for current
	CALL       Light_32Receiver_Read_ATD_Sensors+0
;Light Receiver.mbas,242 :: 		uart_out_buff [0] = Fill_Char                   'We like the results
	MOVLW      13
	MOVWF      _uart_out_buff+0
;Light Receiver.mbas,243 :: 		uart_out_buff [1] = ACK
	MOVLW      6
	MOVWF      _uart_out_buff+1
;Light Receiver.mbas,244 :: 		if ATD_Results <> PortC and 0x0F                'Do current sensors agree with light port?
	MOVLW      15
	ANDWF      PORTC+0, 0
	MOVWF      R1
	MOVF       _ATD_Results+0, 0
	XORWF      R1, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main108
;Light Receiver.mbas,246 :: 		uart_out_buff [0] = PortC and 0x0F
	MOVLW      15
	ANDWF      PORTC+0, 0
	MOVWF      _uart_out_buff+0
;Light Receiver.mbas,247 :: 		uart_out_buff [0] = uart_out_buff [0] or Swap (Atd_Results)
	MOVF       _ATD_Results+0, 0
	MOVWF      FARG_Swap_arg+0
	CALL       _Swap+0
	MOVF       R0, 0
	IORWF       _uart_out_buff+0, 1
;Light Receiver.mbas,248 :: 		uart_out_buff [1] = NAK                  'No, send status in buffer and a NAK
	MOVLW      21
	MOVWF      _uart_out_buff+1
L__main108:
;Light Receiver.mbas,251 :: 		Send_Result
	CALL       Light_32Receiver_Send_Result+0
;Light Receiver.mbas,252 :: 		GoTo Main_01                                    'Loop for More
	GOTO       L__main_main_01
L__main103:
;Light Receiver.mbas,254 :: 		Case Light_Mask                                   'Turn on/off Lights with Mask command
	MOVF       _uart_in_buff+0, 0
	XORLW      69
	BTFSS      STATUS+0, 2
	GOTO       L__main112
;Light Receiver.mbas,255 :: 		if uart_in_buff [1] > 0x0F                      'Second byte must be a nibble
	MOVF       _uart_in_buff+1, 0
	SUBLW      15
	BTFSC      STATUS+0, 0
	GOTO       L__main114
;Light Receiver.mbas,257 :: 		GoTo Report_Error
	GOTO       L__main_report_error
L__main114:
;Light Receiver.mbas,260 :: 		PortC = (PortC and 0xF0) or (uart_in_buff [1] and 0x0F) 'Parse and turn on lights
	MOVLW      240
	ANDWF      PORTC+0, 0
	MOVWF      R1
	MOVLW      15
	ANDWF      _uart_in_buff+1, 0
	MOVWF      R0
	MOVF       R0, 0
	IORWF       R1, 0
	MOVWF      PORTC+0
;Light Receiver.mbas,261 :: 		Read_ATD_Sensors()                               'Check the ATD here for current
	CALL       Light_32Receiver_Read_ATD_Sensors+0
;Light Receiver.mbas,262 :: 		uart_out_buff [0] = Fill_Char                    'We like the results
	MOVLW      13
	MOVWF      _uart_out_buff+0
;Light Receiver.mbas,263 :: 		uart_out_buff [1] = ACK
	MOVLW      6
	MOVWF      _uart_out_buff+1
;Light Receiver.mbas,264 :: 		if ATD_Results <> PortC and 0x0F                 'Do current sensors agree with the light port?
	MOVLW      15
	ANDWF      PORTC+0, 0
	MOVWF      R1
	MOVF       _ATD_Results+0, 0
	XORWF      R1, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main117
;Light Receiver.mbas,266 :: 		uart_out_buff [0] = PortC and 0x0F
	MOVLW      15
	ANDWF      PORTC+0, 0
	MOVWF      _uart_out_buff+0
;Light Receiver.mbas,267 :: 		uart_out_buff [0] = uart_out_buff [0] or Swap (Atd_Results)
	MOVF       _ATD_Results+0, 0
	MOVWF      FARG_Swap_arg+0
	CALL       _Swap+0
	MOVF       R0, 0
	IORWF       _uart_out_buff+0, 1
;Light Receiver.mbas,268 :: 		uart_out_buff [1] = NAK                   'No, send status in buffer and a NAK
	MOVLW      21
	MOVWF      _uart_out_buff+1
L__main117:
;Light Receiver.mbas,271 :: 		Send_Result
	CALL       Light_32Receiver_Send_Result+0
;Light Receiver.mbas,272 :: 		GoTo Main_01                                     'Loop for More
	GOTO       L__main_main_01
L__main112:
;Light Receiver.mbas,274 :: 		Case Report_Port                                   'Return mask of Light Port
	MOVF       _uart_in_buff+0, 0
	XORLW      70
	BTFSS      STATUS+0, 2
	GOTO       L__main121
;Light Receiver.mbas,275 :: 		if uart_in_buff [1] <> Fill_Char              'Second byte must be a fill char
	MOVF       _uart_in_buff+1, 0
	XORLW      13
	BTFSC      STATUS+0, 2
	GOTO       L__main123
;Light Receiver.mbas,277 :: 		GoTo Report_Error
	GOTO       L__main_report_error
L__main123:
;Light Receiver.mbas,279 :: 		uart_out_buff [0] = PortC and 0x0F            'Stuff Results in buffer
	MOVLW      15
	ANDWF      PORTC+0, 0
	MOVWF      _uart_out_buff+0
;Light Receiver.mbas,280 :: 		uart_out_buff [1] = ACK
	MOVLW      6
	MOVWF      _uart_out_buff+1
;Light Receiver.mbas,281 :: 		Send_Result
	CALL       Light_32Receiver_Send_Result+0
;Light Receiver.mbas,282 :: 		GoTo Main_01                                  'Loop for More
	GOTO       L__main_main_01
L__main121:
;Light Receiver.mbas,284 :: 		Case Nop_Inquiry                                   'NOP Send Inquiry
	MOVF       _uart_in_buff+0, 0
	XORLW      74
	BTFSS      STATUS+0, 2
	GOTO       L__main127
;Light Receiver.mbas,285 :: 		if uart_in_buff [1] <> Fill_Char                 'Second byte must be a fill chr
	MOVF       _uart_in_buff+1, 0
	XORLW      13
	BTFSC      STATUS+0, 2
	GOTO       L__main129
;Light Receiver.mbas,287 :: 		GoTo Report_Error
	GOTO       L__main_report_error
L__main129:
;Light Receiver.mbas,289 :: 		Read_ATD_Sensors                                 'Read sensors
	CALL       Light_32Receiver_Read_ATD_Sensors+0
;Light Receiver.mbas,291 :: 		uart_out_buff [1] = Null                       'Prefill for OR functions
	CLRF       _uart_out_buff+1
;Light Receiver.mbas,292 :: 		uart_out_buff [1] = uart_out_buff [1] or (PortC and 0x0F) 'First the Light Port Bits
	MOVLW      15
	ANDWF      PORTC+0, 0
	MOVWF      R0
	MOVF       R0, 0
	IORWF       _uart_out_buff+1, 1
;Light Receiver.mbas,293 :: 		uart_out_buff [1] = uart_out_buff [1] or (Swap(ATD_Results) and 0xF0)
	MOVF       _ATD_Results+0, 0
	MOVWF      FARG_Swap_arg+0
	CALL       _Swap+0
	MOVLW      240
	ANDWF      R0, 1
	MOVF       R0, 0
	IORWF       _uart_out_buff+1, 1
;Light Receiver.mbas,294 :: 		Send_Result
	CALL       Light_32Receiver_Send_Result+0
;Light Receiver.mbas,295 :: 		GoTo Main_01                                      'Loop for More
	GOTO       L__main_main_01
L__main127:
;Light Receiver.mbas,297 :: 		Case Toggle_Light                                 'Off is on on is off
	MOVF       _uart_in_buff+0, 0
	XORLW      71
	BTFSS      STATUS+0, 2
	GOTO       L__main133
;Light Receiver.mbas,298 :: 		Select Case uart_in_buff [1] and 0x0F           'Strip ASCII
	MOVLW      15
	ANDWF      _uart_in_buff+1, 0
	MOVWF      R1
;Light Receiver.mbas,299 :: 		Case 0x01                                     'Must be a single bit
	MOVF       R1, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__main137
;Light Receiver.mbas,300 :: 		goto Toggle_Light_01
	GOTO       L__main_toggle_light_01
L__main137:
;Light Receiver.mbas,301 :: 		Case 0x02                                     'two bits are not allowed
	MOVF       R1, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L__main141
;Light Receiver.mbas,302 :: 		goto Toggle_Light_01
	GOTO       L__main_toggle_light_01
L__main141:
;Light Receiver.mbas,303 :: 		Case 0x04                                     'two bits are not allowed
	MOVF       R1, 0
	XORLW      4
	BTFSS      STATUS+0, 2
	GOTO       L__main144
;Light Receiver.mbas,304 :: 		goto Toggle_Light_01
	GOTO       L__main_toggle_light_01
L__main144:
;Light Receiver.mbas,305 :: 		Case 0x08                                     'two bits are not allowed
	MOVF       R1, 0
	XORLW      8
	BTFSS      STATUS+0, 2
	GOTO       L__main147
;Light Receiver.mbas,306 :: 		goto Toggle_Light_01
	GOTO       L__main_toggle_light_01
L__main147:
;Light Receiver.mbas,308 :: 		uart_out_buff [0] = uart_in_buff [1]            'Send it back error
	MOVF       _uart_in_buff+1, 0
	MOVWF      _uart_out_buff+0
;Light Receiver.mbas,309 :: 		GoTo Report_error
	GOTO       L__main_report_error
;Light Receiver.mbas,310 :: 		Toggle_Light_01:
L__main_toggle_light_01:
;Light Receiver.mbas,311 :: 		PortC = PortC xor (uart_in_buff [1] and 0X0F)    'Strip Ascii
	MOVLW      15
	ANDWF      _uart_in_buff+1, 0
	MOVWF      R0
	MOVF       R0, 0
	XORWF      PORTC+0, 1
;Light Receiver.mbas,312 :: 		uart_out_buff [0] = uart_in_buff [1]           'Send it back Acked
	MOVF       _uart_in_buff+1, 0
	MOVWF      _uart_out_buff+0
;Light Receiver.mbas,313 :: 		uart_out_buff [1] = ACK
	MOVLW      6
	MOVWF      _uart_out_buff+1
;Light Receiver.mbas,314 :: 		Read_ATD_Sensors()                              'Check the ATD here for current
	CALL       Light_32Receiver_Read_ATD_Sensors+0
;Light Receiver.mbas,315 :: 		uart_out_buff [0] = Fill_Char                   'We like the results
	MOVLW      13
	MOVWF      _uart_out_buff+0
;Light Receiver.mbas,316 :: 		uart_out_buff [1] = ACK
	MOVLW      6
	MOVWF      _uart_out_buff+1
;Light Receiver.mbas,317 :: 		if ATD_Results <> PortC and 0x0F                'Do current sensors agree with light port?
	MOVLW      15
	ANDWF      PORTC+0, 0
	MOVWF      R1
	MOVF       _ATD_Results+0, 0
	XORWF      R1, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main149
;Light Receiver.mbas,319 :: 		uart_out_buff [0] = PortC and 0x0F
	MOVLW      15
	ANDWF      PORTC+0, 0
	MOVWF      _uart_out_buff+0
;Light Receiver.mbas,320 :: 		uart_out_buff [0] = uart_out_buff [0] or Swap (Atd_Results)
	MOVF       _ATD_Results+0, 0
	MOVWF      FARG_Swap_arg+0
	CALL       _Swap+0
	MOVF       R0, 0
	IORWF       _uart_out_buff+0, 1
;Light Receiver.mbas,321 :: 		uart_out_buff [1] = NAK                  'No, send status in buffer and NAK
	MOVLW      21
	MOVWF      _uart_out_buff+1
L__main149:
;Light Receiver.mbas,324 :: 		Send_Result
	CALL       Light_32Receiver_Send_Result+0
;Light Receiver.mbas,325 :: 		GoTo Main_01
	GOTO       L__main_main_01
L__main133:
;Light Receiver.mbas,327 :: 		Case Reset_All                                      'Any Reset_ll starts us over and syncs comms
	MOVF       _uart_in_buff+0, 0
	XORLW      73
	BTFSS      STATUS+0, 2
	GOTO       L__main153
;Light Receiver.mbas,328 :: 		PortC = PortC and 0xF0                            'Clear the Lights
	MOVLW      240
	ANDWF      PORTC+0, 1
;Light Receiver.mbas,329 :: 		Read_ATD_Sensors                                  'Calibrate ATD inputs
	CALL       Light_32Receiver_Read_ATD_Sensors+0
;Light Receiver.mbas,330 :: 		ADC_Cal_Data = ADC_Current_Data
	MOVLW      _ADC_CAL_Data+0
	MOVWF      FSR1L
	MOVLW      hi_addr(_ADC_CAL_Data+0)
	MOVWF      FSR1H
	MOVLW      _ADC_Current_Data+0
	MOVWF      FSR0L
	MOVLW      hi_addr(_ADC_Current_Data+0)
	MOVWF      FSR0H
	MOVLW      8
	MOVWF      R0
	MOVLW      1
	MOVWF      R1
	CALL       ___CA2A+0
;Light Receiver.mbas,332 :: 		uart_out_buff [0] = Fill_Char
	MOVLW      13
	MOVWF      _uart_out_buff+0
;Light Receiver.mbas,333 :: 		uart_out_buff [1] = ACK                           'Must be upper case
	MOVLW      6
	MOVWF      _uart_out_buff+1
;Light Receiver.mbas,334 :: 		Send_Result
	CALL       Light_32Receiver_Send_Result+0
;Light Receiver.mbas,335 :: 		GoTo Main_00                                      'Start OVER
	GOTO       L__main_main_00
L__main153:
;Light Receiver.mbas,337 :: 		Case "S"                                            'Short Status (Binary Data)
	MOVF       _uart_in_buff+0, 0
	XORLW      83
	BTFSS      STATUS+0, 2
	GOTO       L__main156
;Light Receiver.mbas,338 :: 		uart_out_buff [0] = "S"
	MOVLW      83
	MOVWF      _uart_out_buff+0
;Light Receiver.mbas,339 :: 		uart_out_buff [1] = ACK
	MOVLW      6
	MOVWF      _uart_out_buff+1
;Light Receiver.mbas,340 :: 		Send_Result
	CALL       Light_32Receiver_Send_Result+0
;Light Receiver.mbas,342 :: 		Read_ATD_Sensors                                  'Refresh Sensors but not Cal Data
	CALL       Light_32Receiver_Read_ATD_Sensors+0
;Light Receiver.mbas,343 :: 		For i = 0 to 3                                    'Send four Words of Cal Data
	CLRF       _i+0
L__main158:
;Light Receiver.mbas,344 :: 		SS_01:
L__main_ss_01:
;Light Receiver.mbas,345 :: 		if (UART1_Tx_Idle = 1)
	CALL       _UART1_TX_Idle+0
	MOVF       R0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__main164
;Light Receiver.mbas,347 :: 		UART1_Write (HI (ADC_Current_Data [i]))    ' write the high byte
	MOVF       _i+0, 0
	MOVWF      R0
	CLRF       R1
	LSLF       R0, 1
	RLF        R1, 1
	MOVLW      _ADC_Current_Data+0
	ADDWF      R0, 1
	MOVLW      hi_addr(_ADC_Current_Data+0)
	ADDWFC     R1, 1
	MOVLW      1
	ADDWF      R0, 0
	MOVWF      FSR0L
	MOVLW      0
	ADDWFC     R1, 0
	MOVWF      FSR0H
	MOVF       INDF0+0, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
	GOTO       L__main165
;Light Receiver.mbas,348 :: 		else
L__main164:
;Light Receiver.mbas,349 :: 		GoTo SS_01
	GOTO       L__main_ss_01
;Light Receiver.mbas,350 :: 		end if
L__main165:
;Light Receiver.mbas,351 :: 		SS_02:
L__main_ss_02:
;Light Receiver.mbas,352 :: 		if (UART1_Tx_Idle = 1)
	CALL       _UART1_TX_Idle+0
	MOVF       R0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__main168
;Light Receiver.mbas,354 :: 		UART1_Write (LO (ADC_Current_Data [i]))    ' write the Low byte
	MOVF       _i+0, 0
	MOVWF      R0
	CLRF       R1
	LSLF       R0, 1
	RLF        R1, 1
	MOVLW      _ADC_Current_Data+0
	ADDWF      R0, 0
	MOVWF      FSR0L
	MOVLW      hi_addr(_ADC_Current_Data+0)
	ADDWFC     R1, 0
	MOVWF      FSR0H
	MOVF       INDF0+0, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
	GOTO       L__main169
;Light Receiver.mbas,355 :: 		else
L__main168:
;Light Receiver.mbas,356 :: 		GoTo SS_02
	GOTO       L__main_ss_02
;Light Receiver.mbas,357 :: 		end if
L__main169:
;Light Receiver.mbas,358 :: 		next i
	MOVF       _i+0, 0
	XORLW      3
	BTFSC      STATUS+0, 2
	GOTO       L__main161
	INCF       _i+0, 1
	GOTO       L__main158
L__main161:
;Light Receiver.mbas,360 :: 		For i = 0 to 3                                    'Send four Words of Current Data
	CLRF       _i+0
L__main171:
;Light Receiver.mbas,361 :: 		SS_03:
L__main_ss_03:
;Light Receiver.mbas,362 :: 		if (UART1_Tx_Idle = 1)
	CALL       _UART1_TX_Idle+0
	MOVF       R0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__main177
;Light Receiver.mbas,364 :: 		UART1_Write (HI (ADC_Cal_Data [i]))        ' write the high byte
	MOVF       _i+0, 0
	MOVWF      R0
	CLRF       R1
	LSLF       R0, 1
	RLF        R1, 1
	MOVLW      _ADC_CAL_Data+0
	ADDWF      R0, 1
	MOVLW      hi_addr(_ADC_CAL_Data+0)
	ADDWFC     R1, 1
	MOVLW      1
	ADDWF      R0, 0
	MOVWF      FSR0L
	MOVLW      0
	ADDWFC     R1, 0
	MOVWF      FSR0H
	MOVF       INDF0+0, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
	GOTO       L__main178
;Light Receiver.mbas,365 :: 		else
L__main177:
;Light Receiver.mbas,366 :: 		GoTo SS_03
	GOTO       L__main_ss_03
;Light Receiver.mbas,367 :: 		end if
L__main178:
;Light Receiver.mbas,368 :: 		SS_04:
L__main_ss_04:
;Light Receiver.mbas,369 :: 		if (UART1_Tx_Idle = 1)
	CALL       _UART1_TX_Idle+0
	MOVF       R0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__main181
;Light Receiver.mbas,371 :: 		UART1_Write (LO (ADC_Cal_Data [i]))          ' write the Low byte
	MOVF       _i+0, 0
	MOVWF      R0
	CLRF       R1
	LSLF       R0, 1
	RLF        R1, 1
	MOVLW      _ADC_CAL_Data+0
	ADDWF      R0, 0
	MOVWF      FSR0L
	MOVLW      hi_addr(_ADC_CAL_Data+0)
	ADDWFC     R1, 0
	MOVWF      FSR0H
	MOVF       INDF0+0, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
	GOTO       L__main182
;Light Receiver.mbas,372 :: 		else
L__main181:
;Light Receiver.mbas,373 :: 		GoTo SS_04
	GOTO       L__main_ss_04
;Light Receiver.mbas,374 :: 		end if
L__main182:
;Light Receiver.mbas,375 :: 		next i
	MOVF       _i+0, 0
	XORLW      3
	BTFSC      STATUS+0, 2
	GOTO       L__main174
	INCF       _i+0, 1
	GOTO       L__main171
L__main174:
;Light Receiver.mbas,377 :: 		SS_05:
L__main_ss_05:
;Light Receiver.mbas,378 :: 		if (UART1_Tx_Idle = 1)
	CALL       _UART1_TX_Idle+0
	MOVF       R0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__main185
;Light Receiver.mbas,380 :: 		UART1_Write (ATD_Results and 0x0F)                       ' write ADC Results
	MOVLW      15
	ANDWF      _ATD_Results+0, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
	GOTO       L__main186
;Light Receiver.mbas,381 :: 		else
L__main185:
;Light Receiver.mbas,382 :: 		GoTo SS_05
	GOTO       L__main_ss_05
;Light Receiver.mbas,383 :: 		end if
L__main186:
;Light Receiver.mbas,385 :: 		SS_06:
L__main_ss_06:
;Light Receiver.mbas,386 :: 		if (UART1_Tx_Idle = 1)
	CALL       _UART1_TX_Idle+0
	MOVF       R0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__main189
;Light Receiver.mbas,388 :: 		UART1_Write (PortC and 0x0F)                 ' write PortC State Results
	MOVLW      15
	ANDWF      PORTC+0, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
	GOTO       L__main190
;Light Receiver.mbas,389 :: 		else
L__main189:
;Light Receiver.mbas,390 :: 		GoTo SS_06
	GOTO       L__main_ss_06
;Light Receiver.mbas,391 :: 		end if
L__main190:
;Light Receiver.mbas,392 :: 		GoTo Main_01                                      'Get Next Command
	GOTO       L__main_main_01
L__main156:
;Light Receiver.mbas,398 :: 		Case "T"                                            'My Testing Routine
	MOVF       _uart_in_buff+0, 0
	XORLW      84
	BTFSS      STATUS+0, 2
	GOTO       L__main193
;Light Receiver.mbas,399 :: 		Uart1_Write (0x0D)
	MOVLW      13
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;Light Receiver.mbas,400 :: 		Uart1_Write (0x0A)
	MOVLW      10
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;Light Receiver.mbas,401 :: 		Read_ATD_Sensors                                  'Read the sensors
	CALL       Light_32Receiver_Read_ATD_Sensors+0
;Light Receiver.mbas,402 :: 		Test_Text [6] = Null                              'terminate the string
	CLRF       _Test_Text+6
;Light Receiver.mbas,403 :: 		for i = 0 to 3
	CLRF       _i+0
L__main195:
;Light Receiver.mbas,404 :: 		Uart1_Write (i+"0")                             'make it ASCII to display
	MOVLW      48
	ADDWF      _i+0, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;Light Receiver.mbas,405 :: 		Uart1_Write_Text ("= ")
	MOVLW      61
	MOVWF      ?LocalText_main+0
	MOVLW      32
	MOVWF      ?LocalText_main+1
	CLRF       ?LocalText_main+2
	MOVLW      ?LocalText_main+0
	MOVWF      FARG_UART1_Write_Text_uart_text+0
	MOVLW      hi_addr(?LocalText_main+0)
	MOVWF      FARG_UART1_Write_Text_uart_text+1
	CALL       _UART1_Write_Text+0
;Light Receiver.mbas,406 :: 		WordToStrWithZeros ((ADC_Current_Data [i]), Test_Text)
	MOVF       _i+0, 0
	MOVWF      R0
	CLRF       R1
	LSLF       R0, 1
	RLF        R1, 1
	MOVLW      _ADC_Current_Data+0
	ADDWF      R0, 0
	MOVWF      FSR0L
	MOVLW      hi_addr(_ADC_Current_Data+0)
	ADDWFC     R1, 0
	MOVWF      FSR0H
	MOVF       INDF0+0, 0
	MOVWF      FARG_WordToStrWithZeros_input+0
	ADDFSR     0, 1
	MOVF       INDF0+0, 0
	MOVWF      FARG_WordToStrWithZeros_input+1
	MOVLW      _Test_Text+0
	MOVWF      FARG_WordToStrWithZeros_output+0
	MOVLW      hi_addr(_Test_Text+0)
	MOVWF      FARG_WordToStrWithZeros_output+1
	CALL       _WordToStrWithZeros+0
;Light Receiver.mbas,407 :: 		Uart1_Write_Text ("Current = ")
	MOVLW      67
	MOVWF      ?LocalText_main+0
	MOVLW      117
	MOVWF      ?LocalText_main+1
	MOVLW      114
	MOVWF      ?LocalText_main+2
	MOVLW      114
	MOVWF      ?LocalText_main+3
	MOVLW      101
	MOVWF      ?LocalText_main+4
	MOVLW      110
	MOVWF      ?LocalText_main+5
	MOVLW      116
	MOVWF      ?LocalText_main+6
	MOVLW      32
	MOVWF      ?LocalText_main+7
	MOVLW      61
	MOVWF      ?LocalText_main+8
	MOVLW      32
	MOVWF      ?LocalText_main+9
	CLRF       ?LocalText_main+10
	MOVLW      ?LocalText_main+0
	MOVWF      FARG_UART1_Write_Text_uart_text+0
	MOVLW      hi_addr(?LocalText_main+0)
	MOVWF      FARG_UART1_Write_Text_uart_text+1
	CALL       _UART1_Write_Text+0
;Light Receiver.mbas,408 :: 		Uart1_Write_Text (Test_Text)
	MOVLW      _Test_Text+0
	MOVWF      FARG_UART1_Write_Text_uart_text+0
	MOVLW      hi_addr(_Test_Text+0)
	MOVWF      FARG_UART1_Write_Text_uart_text+1
	CALL       _UART1_Write_Text+0
;Light Receiver.mbas,409 :: 		WordToStrWithZeros((ADC_Cal_Data [i]), Test_Text)
	MOVF       _i+0, 0
	MOVWF      R0
	CLRF       R1
	LSLF       R0, 1
	RLF        R1, 1
	MOVLW      _ADC_CAL_Data+0
	ADDWF      R0, 0
	MOVWF      FSR0L
	MOVLW      hi_addr(_ADC_CAL_Data+0)
	ADDWFC     R1, 0
	MOVWF      FSR0H
	MOVF       INDF0+0, 0
	MOVWF      FARG_WordToStrWithZeros_input+0
	ADDFSR     0, 1
	MOVF       INDF0+0, 0
	MOVWF      FARG_WordToStrWithZeros_input+1
	MOVLW      _Test_Text+0
	MOVWF      FARG_WordToStrWithZeros_output+0
	MOVLW      hi_addr(_Test_Text+0)
	MOVWF      FARG_WordToStrWithZeros_output+1
	CALL       _WordToStrWithZeros+0
;Light Receiver.mbas,410 :: 		Uart1_Write_Text (" Cal = ")
	MOVLW      32
	MOVWF      ?LocalText_main+0
	MOVLW      67
	MOVWF      ?LocalText_main+1
	MOVLW      97
	MOVWF      ?LocalText_main+2
	MOVLW      108
	MOVWF      ?LocalText_main+3
	MOVLW      32
	MOVWF      ?LocalText_main+4
	MOVLW      61
	MOVWF      ?LocalText_main+5
	MOVLW      32
	MOVWF      ?LocalText_main+6
	CLRF       ?LocalText_main+7
	MOVLW      ?LocalText_main+0
	MOVWF      FARG_UART1_Write_Text_uart_text+0
	MOVLW      hi_addr(?LocalText_main+0)
	MOVWF      FARG_UART1_Write_Text_uart_text+1
	CALL       _UART1_Write_Text+0
;Light Receiver.mbas,411 :: 		Uart1_Write_Text (Test_Text)
	MOVLW      _Test_Text+0
	MOVWF      FARG_UART1_Write_Text_uart_text+0
	MOVLW      hi_addr(_Test_Text+0)
	MOVWF      FARG_UART1_Write_Text_uart_text+1
	CALL       _UART1_Write_Text+0
;Light Receiver.mbas,412 :: 		WordToStrWithZeros (ABS((ADC_Current_Data [i] - ADC_Cal_Data [i])), Test_Text)
	MOVF       _i+0, 0
	MOVWF      R0
	CLRF       R1
	LSLF       R0, 1
	RLF        R1, 1
	MOVLW      _ADC_Current_Data+0
	ADDWF      R0, 0
	MOVWF      R2
	MOVLW      hi_addr(_ADC_Current_Data+0)
	ADDWFC     R1, 0
	MOVWF      R3
	MOVLW      _ADC_CAL_Data+0
	ADDWF      R0, 0
	MOVWF      FSR0L
	MOVLW      hi_addr(_ADC_CAL_Data+0)
	ADDWFC     R1, 0
	MOVWF      FSR0H
	MOVF       INDF0+0, 0
	MOVWF      R0
	ADDFSR     0, 1
	MOVF       INDF0+0, 0
	MOVWF      R1
	MOVF       R2, 0
	MOVWF      FSR0L
	MOVF       R3, 0
	MOVWF      FSR0H
	MOVF       R0, 0
	SUBWF      INDF0+0, 0
	MOVWF      FARG_abs_a+0
	MOVF       R1, 0
	ADDFSR     0, 1
	SUBWFB     INDF0+0, 0
	MOVWF      FARG_abs_a+1
	CALL       _abs+0
	MOVF       R0, 0
	MOVWF      FARG_WordToStrWithZeros_input+0
	MOVF       R1, 0
	MOVWF      FARG_WordToStrWithZeros_input+1
	MOVLW      _Test_Text+0
	MOVWF      FARG_WordToStrWithZeros_output+0
	MOVLW      hi_addr(_Test_Text+0)
	MOVWF      FARG_WordToStrWithZeros_output+1
	CALL       _WordToStrWithZeros+0
;Light Receiver.mbas,413 :: 		Uart1_Write_Text (" Delta = ")
	MOVLW      32
	MOVWF      ?LocalText_main+0
	MOVLW      68
	MOVWF      ?LocalText_main+1
	MOVLW      101
	MOVWF      ?LocalText_main+2
	MOVLW      108
	MOVWF      ?LocalText_main+3
	MOVLW      116
	MOVWF      ?LocalText_main+4
	MOVLW      97
	MOVWF      ?LocalText_main+5
	MOVLW      32
	MOVWF      ?LocalText_main+6
	MOVLW      61
	MOVWF      ?LocalText_main+7
	MOVLW      32
	MOVWF      ?LocalText_main+8
	CLRF       ?LocalText_main+9
	MOVLW      ?LocalText_main+0
	MOVWF      FARG_UART1_Write_Text_uart_text+0
	MOVLW      hi_addr(?LocalText_main+0)
	MOVWF      FARG_UART1_Write_Text_uart_text+1
	CALL       _UART1_Write_Text+0
;Light Receiver.mbas,414 :: 		Uart1_Write_Text (Test_Text)
	MOVLW      _Test_Text+0
	MOVWF      FARG_UART1_Write_Text_uart_text+0
	MOVLW      hi_addr(_Test_Text+0)
	MOVWF      FARG_UART1_Write_Text_uart_text+1
	CALL       _UART1_Write_Text+0
;Light Receiver.mbas,415 :: 		Uart1_Write_Text (" ATD Results = ")
	MOVLW      32
	MOVWF      ?LocalText_main+0
	MOVLW      65
	MOVWF      ?LocalText_main+1
	MOVLW      84
	MOVWF      ?LocalText_main+2
	MOVLW      68
	MOVWF      ?LocalText_main+3
	MOVLW      32
	MOVWF      ?LocalText_main+4
	MOVLW      82
	MOVWF      ?LocalText_main+5
	MOVLW      101
	MOVWF      ?LocalText_main+6
	MOVLW      115
	MOVWF      ?LocalText_main+7
	MOVLW      117
	MOVWF      ?LocalText_main+8
	MOVLW      108
	MOVWF      ?LocalText_main+9
	MOVLW      116
	MOVWF      ?LocalText_main+10
	MOVLW      115
	MOVWF      ?LocalText_main+11
	MOVLW      32
	MOVWF      ?LocalText_main+12
	MOVLW      61
	MOVWF      ?LocalText_main+13
	MOVLW      32
	MOVWF      ?LocalText_main+14
	CLRF       ?LocalText_main+15
	MOVLW      ?LocalText_main+0
	MOVWF      FARG_UART1_Write_Text_uart_text+0
	MOVLW      hi_addr(?LocalText_main+0)
	MOVWF      FARG_UART1_Write_Text_uart_text+1
	CALL       _UART1_Write_Text+0
;Light Receiver.mbas,416 :: 		ByteToHex (ATD_Results, Test_Text)
	MOVF       _ATD_Results+0, 0
	MOVWF      FARG_ByteToHex_input+0
	MOVLW      _Test_Text+0
	MOVWF      FARG_ByteToHex_output+0
	MOVLW      hi_addr(_Test_Text+0)
	MOVWF      FARG_ByteToHex_output+1
	CALL       _ByteToHex+0
;Light Receiver.mbas,417 :: 		Uart1_Write_Text (Test_Text)
	MOVLW      _Test_Text+0
	MOVWF      FARG_UART1_Write_Text_uart_text+0
	MOVLW      hi_addr(_Test_Text+0)
	MOVWF      FARG_UART1_Write_Text_uart_text+1
	CALL       _UART1_Write_Text+0
;Light Receiver.mbas,418 :: 		Uart1_Write_Text (" Light port = ")
	MOVLW      32
	MOVWF      ?LocalText_main+0
	MOVLW      76
	MOVWF      ?LocalText_main+1
	MOVLW      105
	MOVWF      ?LocalText_main+2
	MOVLW      103
	MOVWF      ?LocalText_main+3
	MOVLW      104
	MOVWF      ?LocalText_main+4
	MOVLW      116
	MOVWF      ?LocalText_main+5
	MOVLW      32
	MOVWF      ?LocalText_main+6
	MOVLW      112
	MOVWF      ?LocalText_main+7
	MOVLW      111
	MOVWF      ?LocalText_main+8
	MOVLW      114
	MOVWF      ?LocalText_main+9
	MOVLW      116
	MOVWF      ?LocalText_main+10
	MOVLW      32
	MOVWF      ?LocalText_main+11
	MOVLW      61
	MOVWF      ?LocalText_main+12
	MOVLW      32
	MOVWF      ?LocalText_main+13
	CLRF       ?LocalText_main+14
	MOVLW      ?LocalText_main+0
	MOVWF      FARG_UART1_Write_Text_uart_text+0
	MOVLW      hi_addr(?LocalText_main+0)
	MOVWF      FARG_UART1_Write_Text_uart_text+1
	CALL       _UART1_Write_Text+0
;Light Receiver.mbas,419 :: 		ByteToHex (PortC and 0x0F, Test_Text)
	MOVLW      15
	ANDWF      PORTC+0, 0
	MOVWF      FARG_ByteToHex_input+0
	MOVLW      _Test_Text+0
	MOVWF      FARG_ByteToHex_output+0
	MOVLW      hi_addr(_Test_Text+0)
	MOVWF      FARG_ByteToHex_output+1
	CALL       _ByteToHex+0
;Light Receiver.mbas,420 :: 		Uart1_Write_Text (Test_Text)
	MOVLW      _Test_Text+0
	MOVWF      FARG_UART1_Write_Text_uart_text+0
	MOVLW      hi_addr(_Test_Text+0)
	MOVWF      FARG_UART1_Write_Text_uart_text+1
	CALL       _UART1_Write_Text+0
;Light Receiver.mbas,422 :: 		Uart1_Write (0x0D)
	MOVLW      13
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;Light Receiver.mbas,423 :: 		Uart1_Write (0x0A)
	MOVLW      10
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;Light Receiver.mbas,424 :: 		Next i
	MOVF       _i+0, 0
	XORLW      3
	BTFSC      STATUS+0, 2
	GOTO       L__main198
	INCF       _i+0, 1
	GOTO       L__main195
L__main198:
;Light Receiver.mbas,426 :: 		Uart1_Write (0x0D)
	MOVLW      13
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;Light Receiver.mbas,427 :: 		Uart1_Write (0x0A)
	MOVLW      10
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;Light Receiver.mbas,429 :: 		GoTo Main_01
	GOTO       L__main_main_01
L__main193:
;Light Receiver.mbas,432 :: 		Report_Error:                                             'If none of the cases, then fall into Report_error
L__main_report_error:
;Light Receiver.mbas,433 :: 		uart_out_buff [1] = NAK                           'Error char
	MOVLW      21
	MOVWF      _uart_out_buff+1
;Light Receiver.mbas,434 :: 		Send_Result
	CALL       Light_32Receiver_Send_Result+0
;Light Receiver.mbas,435 :: 		GoTo Main_01
	GOTO       L__main_main_01
L_end_main:
	GOTO       $+0
; end of _main
